"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function Button(_ref) {
  var buttonData = _ref.buttonData,
      scrollPosition = _ref.scrollPosition,
      content = _ref.content,
      onButtonClick = _ref.onButtonClick;

  var _useState = (0, _react.useState)(null),
      _useState2 = _slicedToArray(_useState, 2),
      buttonHeight = _useState2[0],
      changeButtonHeight = _useState2[1];

  var buttonRef = (0, _react.useRef)(null);

  (0, _react.useEffect)(function () {
    if (buttonRef.current) {
      changeButtonHeight(buttonRef.current.offsetHeight);
    }
  }, [buttonData.type]);

  return _react2.default.createElement(
    "div",
    {
      className: "button",
      onClick: onButtonClick,
      ref: buttonRef,
      style: {
        left: buttonData.position.left - scrollPosition.scrollX,
        top: buttonData.position.top - scrollPosition.scrollY - buttonHeight,
        position: "absolute",
        zIndex: 1,
        visibility: buttonHeight ? "visible" : "hidden"
      }
    },
    content
  );
}
exports.default = Button;